#include "ti-85.h"
#include "Peak1.h"

.org 0
MenuTitle:
.db     "Hexadecimal Input",0

        ROM_CALL(CLEARLCD)
        ld (CURSOR_ROW),DE
        ld B,2

KeyLoop:
        push DE
        call GET_KEY
        
        ld HL,KeyTable
        ld DE,(PROGRAM_ADDR)
        add HL,DE
        pop DE

        ld C,0

TableLoop:
        ld D,A
        ld A,(HL)
        or A
        jr Z,KeyLoop
        ld A,D
        
        cp (HL)
        jr Z,GotNumber

        inc HL
        inc C

        jr TableLoop

GotNumber:
        push BC
        ld A,C
        cp $0A
        jr NC,SkipAdd

        ld C,$30
        add A,C

SkipAdd:
        push DE
        call ETR_CHARPUT
        pop DE
        pop BC

        ld A,E

        rlc A
        rlc A
        rlc A
        rlc A

;        sla A
;        sla A
;        sla A
;        sla A

        or C
        ld E,A

        dec B
        jr NZ,KeyLoop

Display:
        ld L,E
        ld H,0

        ROM_CALL(D_HL_DECI)

Pause:
        call GET_KEY
        or A
        jr Z,Pause
        ret

KeyTable:
.db     K_0,K_1,K_2,K_3,K_4,K_5,K_6,K_7,K_8,K_9
.db     K_LOG,K_SIN,K_COS,K_TAN,K_RAISE,K_LN,0


.end


