#include "ti-85.h"
#include "Peak1.h"

STR_SPOT        =TEXT_MEM2
MAX             =TEXT_MEM2+2
STRING          =TEXT_MEM2+3

.org 0
MenuTitle:
.db     "String Input",0

        PAFFECT_TEXT
        ROM_CALL(CLEARTEXT)

        ld DE,0
        ld (CURSOR_ROW),DE

        ld B,0
        ld A,8

StringInput:
        ld (MAX),A

        ROM_CALL(GET_T_CUR)
        ld (STR_SPOT),HL

        CURSOR_ON

KeyLoop:
        call GET_KEY

;        cp K_SECOND
;        jr Z,Second

        cp K_ALPHA
        jr Z,Alpha

        cp K_ENTER
        JUMP_Z(Enter)

        cp K_DEL
        jr Z,Delete

        ld L,A
        ld A,(MAX)
        cp B
        jr Z,KeyLoop
        ld A,L

        cp K_SIGN
        jr Z,Space

        ld HL,AlphaTable

        bit 4,(IY+$12)
        jr NZ,SkipNumber

        ld HL,NumberTable

SkipNumber:
        ld DE,(PROGRAM_ADDR)
        add HL,DE

        ld C,0
        ld E,A

ALPHALoop:
        ld A,(HL)
        or A
        jr Z,KeyLoop

        cp E
        jr Z,FoundALPHA

        inc C
        inc HL

        jr ALPHALoop

;Second:
;        bit 3,(IY+$12)
;        jr Z,SetSecond
;
;        SECOND_OFF
;        jr KeyLoop
;
;SetSecond:
;        SECOND_ON
;        jr KeyLoop

Alpha:
        bit 4,(IY+$12)
        jr Z,SetAlpha

        bit 5,(IY+$12)
        jr Z,BAlpha

        ALPHA_OFF

        jr KeyLoop

BAlpha:
        USE_alpha
        jr KeyLoop

SetAlpha:
        ALPHA_ON
        USE_ALPHA

KeyLoop3:
        jr KeyLoop

Space:
        ld A,$20
        jr LoadChar

FoundALPHA:
        ld A,$28
        bit 4,(IY+$12)
        jr Z,BigA

        add A,$19

        bit 5,(IY+$12)
        jr Z,BigA

        add A,$20

BigA:
        add A,C

LoadChar:
        call ETR_CHARPUT

        inc B

KeyLoop2:
        jr KeyLoop

Delete:
        ROM_CALL(GET_T_CUR)
        ld DE,(STR_SPOT)
        call CP_HL_DE
        jr Z,KeyLoop2

        ld HL,(CURSOR_ROW)

        push HL
        ld A,$20
        call ETR_CHARPUT
        xor A
        cp H
        jr NZ,Normal

        ld H,20
        dec L
        jr NNormal

Normal:
        dec H

NNormal:
        ld (CURSOR_ROW),HL
        push HL

        ld A,$20
        call ETR_CHARPUT

        pop HL
        ld (CURSOR_ROW),HL
        dec B
        jr KeyLoop2

Enter:
        push BC
        ld HL,(STR_SPOT)
        ld DE,STRING+1
        ld C,B
        inc C
        ld B,0
        ldir
        pop BC

        xor A
        ld (DE),A

        ld HL,STRING
        ld (HL),B

        PNO_AFFECT_TEXT

Display:
        CURSOR_OFF
        ROM_CALL(CLEARLCD)
        ld (CURSOR_ROW),DE

        CALL_(Pause)

        ld HL,STRING

        ROM_CALL(D_LT_STR)

Pause:
        call GET_KEY
        or A
        jr Z,Pause
        ret

AlphaTable:
.db     $2E,$26,$1E,$16,$0E
.db     $2D,$25,$1D,$15,$0D
.db     $2C,$24,$1C,$14,$0C
.db     $2B,$23,$1B,$13,$0B
.db     $22,$1A,$12,$0A
.db     $21,$19
.db     0

NumberTable:
.db     $1D,$15,$0C,$0A,$2B,$0B,$19,$0D
.db     $21,$22,$1A,$12,$23,$1B,$13,$24,$1C,$14
.db     0

.end


